/*******************************************
 *
 * Fahrradschuppen Licht Klickselklacksel
 *
 * (C) Fingers elektrische Welt 2010
 *
 *******************************************/
#include <p18cxxx.h>
#include <p18F452.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include "defines.h"

#pragma config OSC = HS

// >----- Mach mal Pause ---------<

#define	XTAL_FREQ	4MHZ		      // Jaja, ich WEISS dass das falsch ist *Grummel*                  
#define	MHZ	*1000			                            

#define	DelayUs(x)	{ unsigned int _dcnt; \
			  _dcnt = (x)/(12MHZ/(XTAL_FREQ))|1; \
			  while(--_dcnt != 0) \
				  continue; }



// >----- Mach mal Pause ---------<

// Diverses
char outpbuf [Buflen];                      // Ausgabepuffer;
volatile unsigned long Timerticks = 0;			// Systemticker alle 10ms
unsigned char Taster;

// Zeitmessung
volatile unsigned long SekundenTicker = 0;  // Systemticker jede Sekunde ++

// Lichtmessung
unsigned int Lichtwert [LichtPufferGroesse];
char Lichtzeiger = 0;
volatile unsigned int LichtTimer = 0; 

// Statusse, Statuten, Stati oder was auch immer.....
unsigned char LichtFlag = FALSE;            // Isses an oder aus ? Wat denn nu ??????
unsigned char TimerFlag = FALSE;			// Soll der Timer laufen oder nicht ?	
unsigned char DasLichtwarnochnichtanbisher = Nedatwarnochnichamleuctentun;
unsigned char AltTaster;

//-------------------------------------------------
// Konfiguration des Controllers
//-------------------------------------------------
/*
__CONFIG(1, OSCEN & HS);         // HS = Quarz
__CONFIG(2, BORV45 & WDTEN);       // Watchdog, BrownOut 4.5V
__CONFIG(4, LVPDIS & STVREN);     // Kein LowVoltageProgramm, Reset bei StackOverflow
*/

void main (void);
void InterruptHandlerHigh (void);

/**************************
 *
 * Systemticker erhhen
 *
 **************************/
void Systemticker (void)
 {
  Timerticks++;

  //-------------------------
  // Sekundenweise ausfhren
  //-------------------------
  if ((Timerticks % 100) == 0)
   {

    // Sekundenzhler
    SekundenTicker++;
    if ( (TimerFlag) && (LichtTimer > 0) ) LichtTimer--;

   } // Von if ((Timerticks % 100) == 0)

 }

/**************************
 *
 * Systemticker auslesen
 *
 **************************/
long Get_Ticker (void)
 {
  return (Timerticks);
 }

/*************************************
 *
 * Verzgern im Millisekundenbereich
 *
 *************************************/
void Delayms (int time)
 {
  unsigned long ticker;

  ticker = Get_Ticker ();

  while ( (ticker + (time / 10)) > Get_Ticker () )
   {
    ClrWdt();    
   }
 }

//----------------------------------------------------------------------------
// High priority interrupt vector

#pragma code InterruptVectorHigh = 0x08
void
InterruptVectorHigh (void)
{
  _asm
    goto InterruptHandlerHigh //jump to interrupt routine
  _endasm
}


//----------------------------------------------------------------------------
// High priority interrupt routine

#pragma code
#pragma interrupt InterruptHandlerHigh

void
InterruptHandlerHigh ()
{
   //--------------------
   // Timer 1 berlauf ?
   //--------------------
   if (PIR1bits.TMR1IF)
   	{

      Systemticker ();                                  // Systemticker erhhen

      PIR1bits.TMR1IF=0;                                         // Clear Interrupt-Flag

      // Werte fr 10 MHz
      TMR1L=0xCB;                                       // Timer 1 neu vorladen (0xF3CB = 10ms)
      TMR1H=0xF3;                                       // n = 2^16 - t [s] * 625000

   	} // From Timer 1 berlauf

   return;									                            // Zurck zum Hauptprogramm

}


/******************************
 *
 * Startklar machen den Eimer
 *
 ******************************/
void sysinit (void)
 {
  char i = 0;

  TRISA = 0b00000001;           // AN0 = Lichtsensor
  TRISB = 0b00000010;           // RB0 = Relais; RB1 = Taster
  TRISC = 0b00000000;

  LichtAus();

  ClrWdt();

  //------------
  // Timer-Init
  //------------
  PIE1bits.TMR1IE=1;									                      // enable Interrupt of TMR1
  T1CON=49;									                      // Prescaler=1:8 + Timer on (49)
  INTCONbits.PEIE=1;          							                  // Peripherie Int=on
  INTCONbits.GIE=1;										                      // Define Interupts
  ClrWdt();

  //--------------------------
  // AD-Wandler-Einstellungen
  //--------------------------
  ADCON0bits.ADCS1 = 1;
  ADCON0bits.ADCS0 = 0;
  ADCON0bits.ADON = 1;             // Wandler ein
  ADCON1bits.ADFM = 1;             // Rechtsseitig

  ADCON1bits.PCFG3 = 0;            // Externe Referenz, alle Kanle Analog
  ADCON1bits.PCFG2 = 0;
  ADCON1bits.PCFG1 = 0;
  ADCON1bits.PCFG0 = 0;

  // Puffer leeren
   for (i=0; i < LichtPufferGroesse; i++)
     Lichtwert [i] = 0;  // Hellwert
 
  // Flankenerkennung
  Taster = PORTB & 0b00000010;
  AltTaster = Taster;

 }

/***************************
 *
 * Wandlerwert reinlutschen
 *
 ***************************/
unsigned int ADCGetRaw (char channel)
 {
  //-----------------
  // Wo solls rein ?
  //-----------------
 /* if (channel & 0b100) ADCON0bits.CHS2 = 1; else */ ADCON0bits.CHS2 = 0;
 /* if (channel & 0b010) ADCON0bits.CHS1 = 1; else */ ADCON0bits.CHS1 = 0;
 /* if (channel & 0b001) ADCON0bits.CHS0 = 1; else */ ADCON0bits.CHS0 = 0;
  DelayUs (1000);  // Kondensator laden
  ADCON0bits.GO = 1;     // Los gehts
  while (ADCON0bits.GO);

  return (ADRES);
 }

/*****************************
 *
 * Isset Hell oder Dunkel ?
 *
 *****************************/
char GetLicht (void)
 {
   char i;
   unsigned int Mittelwert = 0;

   // Wert reinholen und in Puffer stopfen. Nur wenn Lampe aus
   if (!LichtFlag)
    {
	   Lichtwert [Lichtzeiger] = ADCGetRaw (0);
	   Lichtzeiger++;
	   if (Lichtzeiger >= LichtPufferGroesse) Lichtzeiger = 0;
    }

   // Mittelwert bilden
   for (i=0; i < LichtPufferGroesse; i++)
    {
     Mittelwert += Lichtwert [i];
    }
   Mittelwert /= LichtPufferGroesse;

   // Mit Schwelle vergleichen
   if (Mittelwert > Dunkelschwelle) return (TRUE); else return (FALSE);
 }

/***************************************
 *
 * Hier geht das total los das Mopped !
 *
 ***************************************/
void main()
{
  sysinit ();

  // Mach das hier mal, bis du kotzen musst
  while (1)
   {
    ClrWdt();

    // Isset gezt dungl oder wat ?
    if ( (GetLicht ()) && (DasLichtwarnochnichtanbisher) ) 
     {
       DasLichtwarnochnichtanbisher = Jetztissesdaserstemalan;					// Erstmal die Tr zumachen hier
	   LichtTimer = Einschaltzeit;												// Timer vorbelegen
       TimerFlag = TRUE;														// Timer starten	
     }

    // Hat jetzt irgend ein hinrverbranntes Arschloch seine unegalen Wichsgriffen auf den Taster gepatscht ?
	Taster = PORTB & 0b00000010;
    if (Taster != AltTaster)
	 {
       // Isses nicht an ?
       if (LichtFlag)
        { // An wird zu aus
		   DasLichtwarnochnichtanbisher = Jetztissesdaserstemalan;					// Erstmal die Tr zumachen hier
		   LichtTimer = 0;															// Timer vorbelegen
	       TimerFlag = FALSE;														// Timer anhalten
		} else
        { // Aus wird zu an
		   DasLichtwarnochnichtanbisher = Jetztissesdaserstemalan;					// Erstmal die Tr zumachen hier
		   LichtTimer = 1;															// Timer vorbelegen
	       TimerFlag = FALSE;														// Timer anhalten	
		}
	       
         AltTaster = Taster;			// Alten Zustand abtuppern
       Delayms (100);
	 }

    // Hell oder dunkel ? Wat httnse denn jern ?
    if (LichtTimer > 0) { LichtAn(); LichtFlag = TRUE; } else { LichtAus(); LichtFlag = FALSE; }

    Delayms (100);

   } // Von While (1)

} // Thats all folks

